function Opdracht4

hx=0.001;
x=0:hx:1; x=x*pi;

hy=0.0005;
y=0:hy:1; y=y*pi;

%%%%% manieren om een functie te definieren
%%% Merk op dat de functies coordinaatsgewijze vermenigvuldigingen 
%%% van array's toestaan. Waarom is dat handig?
%  function f=MyFunction(x,y)  %%% zie hieronder
F=inline('sin(x).*sin(2*y)','x','y');
Fstr='sin(X).*sin(2*Y)';

lx=length(x); ly=length(y);
f=zeros(lx,ly); X=zeros(lx,ly); Y=zeros(lx,ly);
fprintf('\nde array''s zijn %d bij %d\n',lx,ly)
%=================================

N=5;

close all
tic
for j=1:N
  [X,Y]=ndgrid(x,y);
  f=MyFunction(X,Y);
end
fprintf('Elapsed time: %g (function subroutine 1)\n',toc/N)
%=================================
close all
tic
for j=1:N
  [X,Y]=ndgrid(x,y);
  f=MyFunction(X,Y);
end
fprintf('Elapsed time: %g (function subroutine 1)\n',toc/N)
%=================================
close all
tic
for j=1:N
  [X,Y]=ndgrid(x,y);
  f=feval('MyFunction',X,Y);
end
fprintf('Elapsed time: %g (feval function subroutine)\n',toc/N)

%=================================
close all
tic
for j=1:N
  [X,Y]=ndgrid(x,y);
  f=F(X,Y);
end
fprintf('Elapsed time: %g (inline function)\n',toc/N)
%=================================
close all
tic
for j=1:N
  [X,Y]=ndgrid(x,y);
  f=eval(Fstr);
end
fprintf('Elapsed time: %g (eval string)\n',toc/N)
%=================================
close all
tic
f=zeros(lx,ly);
for i=1:lx
  for j=1:ly
    f(i,j)=MyFunction(x(i),y(j));
  end
end
fprintf('Elapsed time: %g (function subroutine en loops)\n',toc)


%%% Hieronder wordt de functie pas bij het commando om functiewaarden
%%% te berekenen gedefineerd. Waarom is dat in het algemeen niet handig?
%=================================
close all
tic
  f=zeros(lx,ly);
  for i=1:lx
    for j=1:ly
      f(i,j)=sin(x(i)).*sin(2*y(j));
    end
  end
  t=toc;
fprintf('Elapsed time: %g (loops en ter plekke gefinieerde functie)\n',toc)

%=================================
close all
tic
  [X,Y]=ndgrid(x,y);
  f=sin(X).*sin(2*Y);;
fprintf('Elapsed time: %g (met ter plekke gedefinieerde functie)\n',toc)
%=================================

%%% X en Y worden eenmalig uitgerekend en opgeslagen
%%% en gebruikt voor het berekenen van meerdere functies
close all
tic
for j=1:N
  f=MyFunction(X,Y);
end
fprintf('Elapsed time: %g (function subroutine, X en Y al beschikbaar)\n',toc/N)

mesh(X,Y,f)

return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function f=MyFunction(x,y)

  f=sin(x).*sin(2*y);

return



